QuantLib: StochasticProcessArray Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.6

- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | List of all members
StochasticProcessArray Class Reference
Stochastic processes

Array of correlated 1-D stochastic processes More...

`#include <ql/processes/stochasticprocessarray.hpp>`

Inheritance diagram for StochasticProcessArray:
[legend]

## Public Member Functions
| StochasticProcessArray (const std::vector< boost::shared_ptr< StochasticProcess1D > > &, const Matrix &correlation)
Size | size () const
| returns the number of dimensions of the stochastic process
Disposable< Array > | initialValues () const
| returns the initial values of the state variables
Disposable< Array > | drift (Time t, const Array &x) const
| returns the drift part of the equation, i.e., \( \mu(t, \mathrm{x}_t) \)
Disposable< Array > | expectation (Time t0, const Array &x0, Time dt) const
Disposable< Matrix > | diffusion (Time t, const Array &x) const
| returns the diffusion part of the equation, i.e. \( \sigma(t, \mathrm{x}_t) \)
Disposable< Matrix > | covariance (Time t0, const Array &x0, Time dt) const
Disposable< Matrix > | stdDeviation (Time t0, const Array &x0, Time dt) const
Disposable< Array > | apply (const Array &x0, const Array &dx) const
Disposable< Array > | evolve (Time t0, const Array &x0, Time dt, const Array &dw) const
Time | time (const Date &) const
const boost::shared_ptr< StochasticProcess1D > & | process (Size i) const
Disposable< Matrix > | correlation () const
Public Member Functions inherited from StochasticProcess
virtual Size | factors () const
| returns the number of independent factors of the process
void | update ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< std::set< boost::shared_ptr< Observable > >::iterator, bool > | registerWith (const boost::shared_ptr< Observable > &)
void | registerWithObservables (const boost::shared_ptr< Observer > &)
Size | unregisterWith (const boost::shared_ptr< Observable > &)
void | unregisterWithAll ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()

## Protected Attributes
std::vector< boost::shared_ptr< StochasticProcess1D > > | processes_
Matrix | sqrtCorrelation_
Protected Attributes inherited from StochasticProcess
boost::shared_ptr< discretization > | discretization_

## Additional Inherited Members
Protected Member Functions inherited from StochasticProcess
| StochasticProcess (const boost::shared_ptr< discretization > &)

## Detailed Description

Array of correlated 1-D stochastic processes

## Member Function Documentation

Disposable<Array> expectation | ( | Time | t0,
|  | const Array & | x0,
|  | Time | dt
| ) |  | const
| virtual

returns the expectation \( E(\mathrm{x}_{t_0 + \Delta t} | \mathrm{x}_{t_0} = \mathrm{x}_0) \) of the process after a time interval \( \Delta t \) according to the given discretization. This method can be overridden in derived classes which want to hard-code a particular discretization.

Reimplemented from StochasticProcess.

Disposable<Matrix> covariance | ( | Time | t0,
|  | const Array & | x0,
|  | Time | dt
| ) |  | const
| virtual

returns the covariance \( V(\mathrm{x}_{t_0 + \Delta t} | \mathrm{x}_{t_0} = \mathrm{x}_0) \) of the process after a time interval \( \Delta t \) according to the given discretization. This method can be overridden in derived classes which want to hard-code a particular discretization.

Reimplemented from StochasticProcess.

Disposable<Matrix> stdDeviation | ( | Time | t0,
|  | const Array & | x0,
|  | Time | dt
| ) |  | const
| virtual

returns the standard deviation \( S(\mathrm{x}_{t_0 + \Delta t} | \mathrm{x}_{t_0} = \mathrm{x}_0) \) of the process after a time interval \( \Delta t \) according to the given discretization. This method can be overridden in derived classes which want to hard-code a particular discretization.

Reimplemented from StochasticProcess.

Disposable<Array> apply | ( | const Array & | x0,
|  | const Array & | dx
| ) |  | const
| virtual

applies a change to the asset value. By default, it returns \( \mathrm{x} + \Delta \mathrm{x} \).

Reimplemented from StochasticProcess.

Disposable<Array> evolve | ( | Time | t0,
|  | const Array & | x0,
|  | Time | dt,
|  | const Array & | dw
| ) |  | const
| virtual

returns the asset value after a time interval \( \Delta t \) according to the given discretization. By default, it returns

\[ E(\mathrm{x}_0,t_0,\Delta t) + S(\mathrm{x}_0,t_0,\Delta t) \cdot \Delta \mathrm{w} \]

where \( E \) is the expectation and \( S \) the standard deviation.

Reimplemented from StochasticProcess.

Time time | ( | const Date & |  | ) | const
| virtual

returns the time value corresponding to the given date in the reference system of the stochastic process.

Note
  As a number of processes might not need this functionality, a default implementation is given which raises an exception.

Reimplemented from StochasticProcess.